package com.javacodegeeks.examples;

import static org.junit.Assert.*;

import org.junit.Test;

public class MathPowTest {

    @Test
    public void range() {
        System.out.println("\n**** range ****");
 
        int base = 2;
        for (int exponent = 0; exponent <= 16; exponent++) {
            System.out.println(
                String.format("%d^%d = %,d", 
                    base,
                    exponent, 
                    (int) Math.pow(base, exponent)));
        }
    }
 
    @Test
    public void fpCalc() {
        System.out.println("\n**** fpCalc ****");
         
        double result = Math.pow(2.21, 2);
        System.out.println("Math.pow(2.21, 2) = " + result);
        assertTrue(result == 4.8841);
    }
     
    @Test
    public void fractionalExponent() {
        System.out.println("\n**** fractionalExponent ****");
         
        System.out.println(Math.pow(8, 1/3));
         
        double oneThird = (double) 1/3;     
        double result = Math.pow(8, oneThird);      
        System.out.println("Math.pow(8, oneThird) = " + result);
        assertTrue(result == 2);
    }
     
    @Test
    public void productOfPowers() {
        System.out.println("\n**** productOfPowers ****");
         
        double base = 2;
        double exp1 = 2;
        double exp2 = 3;
 
        double res1 = Math.pow(base, exp1);
        double res2 = Math.pow(base, exp2);
 
        System.out.println("result 1: " + res1);
        System.out.println("result 2: " + res2);
 
        double res3 = Math.pow(base, exp1 + exp2);
        System.out.println("result 3: " + res3);
 
        assertTrue(res1 * res2 == res3);
    }

}
