package com.javacodegeeks.examples;

import static org.junit.Assert.*;

import org.junit.Test;

public class SpecialCasesTest {

    @Test
    public void aOrbEqNaN() {
        System.out.println("\n**** aOrbEqNaN ****");
 
        // 1. If the first argument is NaN then the result is NaN.
        System.out.println(Math.pow(Double.NaN, 2));
        assertTrue(Double.isNaN(Math.pow(Double.NaN, 2)));
 
        // 1. If the second argument is NaN then the result is NaN.
        System.out.println(Math.pow(2, Double.NaN));
        assertTrue(Double.isNaN(Math.pow(2, Double.NaN)));
    }
 
    @Test
    public void aEqAnyAndbEqZero() {
        System.out.println("\n**** aEqAnyAndbEqZero ****");
 
        // 2. If a is any value except NaN and b = 0 then the result is 1.0.
        System.out.println(Math.pow(2, 0));
        assertTrue(Math.pow(2, 0) == 1);
    }
 
    @Test
    public void aEqNegativeInfinityAndbGtZero() {
        System.out.println("\n**** aEqNegativeInfinityAndbGtZero ****");
 
        // 3. If a = NegativeInfinity and b is < 0 then the result is 0.0.
        System.out.println(Math.pow(Double.NEGATIVE_INFINITY, -1));
        assertTrue(Math.pow(Double.NEGATIVE_INFINITY, -1) == 0);
    }
 
    @Test
    public void aEqNegativeInfinityAndbIsPostiveOddInt() {
        System.out.println("\n**** aEqNegativeInfinityAndbIsPostiveOddInt ****");
 
        // 4. If a = NegativeInfinity and b is a + odd integer then the result is
        // NegativeInfinity.
        System.out.println(Math.pow(Double.NEGATIVE_INFINITY, 1));
        assertTrue(Math.pow(Double.NEGATIVE_INFINITY, 1) == Double.NEGATIVE_INFINITY);
    }
 
    @Test
    public void aEqNegativeInfinityAndbIsNotPostiveOddInt() {
        System.out.println("\n**** aEqNegativeInfinityAndbIsNotPostiveOddInt ****");
 
        // 5. If a = NegativeInfinity and b is not a + odd integer then the result is PositiveInfinity.
        System.out.println(Math.pow(Double.NEGATIVE_INFINITY, 2));
        assertTrue(Math.pow(Double.NEGATIVE_INFINITY, 2) == Double.POSITIVE_INFINITY);
 
        // 5. If a = NegativeInfinity and b is not a + odd integer, then the result is PositiveInfinity.
        System.out.println(Math.pow(Double.NEGATIVE_INFINITY, 1.5));
        assertTrue(Math.pow(Double.NEGATIVE_INFINITY, 1.5) == Double.POSITIVE_INFINITY);
    }
 
    @Test
    public void aLtZeroAndbNotInteger() {
        System.out.println("\n**** aLtZeroAndbNotInteger ****");
 
        // 6. If a < 0 and b is not an integer, then the result is NaN.
        System.out.println(Math.pow(-1, 2.1));
        assertTrue(Double.isNaN(Math.pow(-1, 2.1)));
    }
 
    @Test
    public void aEqNegative1AndbEqNegativeInfinityOrPositiveInfinity() {
        System.out.println("\n**** aEqNegative1AndbEqNegativeInfinityOrPositiveInfinity ****");
 
        // 7. If a = -1 and b = NegativeInfinity, then the result is NaN.
        System.out.println(Math.pow(-1, Double.NEGATIVE_INFINITY));
        assertTrue(Double.isNaN(Math.pow(-1, Double.NEGATIVE_INFINITY)));
 
        // 7. If a = -1 and b = PositiveInfinity, then the result is NaN.
        System.out.println(Math.pow(-1, Double.POSITIVE_INFINITY));
        assertTrue(Double.isNaN(Math.pow(-1, Double.POSITIVE_INFINITY)));
    }
 
    @Test
    public void aGtNegative1ButLtPosive1AndbEqNegativeInfinity() {
        System.out.println("\n**** aGtNegative1ButLtPosive1AndbEqNegativeInfinity ****");
 
        // 8. If a > -1 but < 1 and b = NegativeInfinity then the result is PositiveInfinity.
        System.out.println(Math.pow(-0.5, Double.NEGATIVE_INFINITY));
        assertTrue(Math.pow(-0.5, Double.NEGATIVE_INFINITY) == Double.POSITIVE_INFINITY);
    }
 
    @Test
    public void aGtNegative1ButLtPositve1AndbEqPositiveInfinity() {
        System.out.println("\n**** aGtNegative1ButLtPositve1AndbEqPositiveInfinity ****");
         
        // 9. If a > -1 but < 1 and b = PositiveInfinity then the result is 0.
        System.out.println(Math.pow(-0.5, Double.POSITIVE_INFINITY));
        assertTrue(Math.pow(-0.5, Double.POSITIVE_INFINITY) == 0);
    }
 
    @Test
    public void aLtNegative1OrGtPositive1AndbEqNegativeInfinity() {
        System.out.println("\n**** aLtNegative1OrGtPositive1AndbEqNegativeInfinity ****");
 
        // 10. If a < -1 and b = NegativeInfinity, then the result is 0.
        System.out.println(Math.pow(-1.5, Double.NEGATIVE_INFINITY));
        assertTrue(Math.pow(-1.5, Double.NEGATIVE_INFINITY) == 0);
 
        // 10. If a > 1 and b equals NegativeInfinity, then the result is 0.
        System.out.println(Math.pow(1.5, Double.NEGATIVE_INFINITY));
        assertTrue(Math.pow(1.5, Double.NEGATIVE_INFINITY) == 0);
    }
 
    @Test
    public void aLtNegative1OrGtPositive1AndbEqPositiveInfinity() {
        System.out.println("\n**** aLtNegative1OrGtPositive1AndbEqPositiveInfinity ****");
 
        // 11. If a < -1 and b = PositiveInfinity then the result is PositiveInfinity.
        System.out.println(Math.pow(-1.5, Double.POSITIVE_INFINITY));
        assertTrue(Math.pow(-1.5, Double.POSITIVE_INFINITY) == Double.POSITIVE_INFINITY);
         
        // 11. If a > 1 and b = PositiveInfinity then the result is PositiveInfinity.
        System.out.println(Math.pow(1.5, Double.POSITIVE_INFINITY));
        assertTrue(Math.pow(1.5, Double.POSITIVE_INFINITY) == Double.POSITIVE_INFINITY);
    }
 
    @Test
    public void aEqZeroAndbLtZero() {
        System.out.println("\n**** aEqZeroAndbLtZero ****");
 
        // 12. If a = 0 and b < 0 the result is PositiveInfinity.
        System.out.println(Math.pow(0, -1));
        assertTrue(Math.pow(0, -1) == Double.POSITIVE_INFINITY);
    }
 
    @Test
    public void aEqZeroAndbGtZero() {
        System.out.println("\n**** aEqZeroAndbGtZero ****");
 
        // 13. If a = 0 and b > 0 the result is 0.
        System.out.println(Math.pow(0, 1));
        assertTrue(Math.pow(0, 1) == 0);
    }
 
    @Test
    public void aEqOneAndbAny() {
        System.out.println("\n**** aEqOneAndbAny ****");
 
        // 14. If a = 1 and b is any value except NaN the result is 1.
        System.out.println(Math.pow(1, 500));
        assertTrue(Math.pow(1, 500) == 1);
    }
 
    @Test
    public void aEqPositiveInfinityAndbLtZero() {
        System.out.println("\n**** aEqPositiveInfinityAndbLtZero ****");
 
        // 15. If a = PositiveInfinity and b is < 0 the result is 0.
        System.out.println(Math.pow(Double.POSITIVE_INFINITY, -1));
        assertTrue(Math.pow(Double.POSITIVE_INFINITY, -1) == 0);
    }
 
    @Test
    public void aEqPositiveInfinityAndbGtZero() {
        System.out.println("\n**** aEqPosInfinityAndbGtZero ****");
 
        // 16. If a = PositiveInfinity and b is > 0 the result is PositiveInfinity.
        System.out.println(Math.pow(Double.POSITIVE_INFINITY, 1));
        assertTrue(Math.pow(Double.POSITIVE_INFINITY, 1) == Double.POSITIVE_INFINITY);
    }
}
